function np_array_calc(i,i1,i2,i4)
%CALCULATION OF NP ARRAY (connectivity)
global  npn
global  np
global  numele
global  numel
global  meltyp
global  xord
global  yord

jbgn = 1;
jend = i4;
kbgn = 1;
kend = i1;

for j=jbgn:1:jend

    for  k=kbgn:1:kend

        switch meltyp
            case 3
                numele = numele+2;
                n1=numele-1;
                n2=numele;
            case 4
                numele = numele+1;
                n1=numele;
            case 6
                numele = numele+2;
                n1=numele-1;
                n2=numele;
            case 9
                numele = numele+1;
                n1=numele;
        end

        if(meltyp==3)
            k1=(j-1)*i2+(k-1)+1;
            k2=k1+1;
            k3=k1+i2;
            k4=k3+1;

            k1=npn(k1);
            k2=npn(k2);
            k3=npn(k3);
            k4=npn(k4);


            d1 = (xord(k4)-xord(k1))^2+(yord(k4)-yord(k1))^2;
            d1 = d1*1.001;
            d2 = (xord(k3)-xord(k2))^2+(yord(k3)-yord(k2))^2;
            if(d2>=d1)
                np(n2,1)=k1;
                np(n2,2)=k2;
                np(n2,3)=k4;
                np(n1,1)=k1;
                np(n1,2)=k4;
                np(n1,3)=k3;
            end
            if(d2<d1)
                np(n2,1)=k1;
                np(n2,2)=k2;
                np(n2,3)=k3;
                np(n1,1)=k3;
                np(n1,2)=k2;
                np(n1,3)=k4;
            end
        end

        if(meltyp==4)
            k1=(j-1)*i2+(k-1)+1;
            k2=k1+1;
            k3=k1+i2;
            k4=k3+1;

            k1=npn(k1);
            k2=npn(k2);
            k3=npn(k3);
            k4=npn(k4);
            np(n1,1) = k1;
            np(n1,2) = k2;
            np(n1,3) = k4;
            np(n1,4) = k3;
        end


        if(meltyp==6)

            k1=2*(j-1)*i2+2*(k-1)+1;
            k2=k1+1;
            k3=k1+2;

            k4=k1+i2;
            k5=k4+1;
            k6=k4+2;

            k7=k1+2*i2;
            k8=k7+1;
            k9=k7+2;

            k1=npn(k1);
            k2=npn(k2);
            k3=npn(k3);
            k4=npn(k4);
            k5=npn(k5);
            k6=npn(k6);
            k7=npn(k7);
            k8=npn(k8);
            k9=npn(k9);

            d1 = (xord(k9)-xord(k1))^2+(yord(k9)-yord(k1))^2;
            d1 = d1*1.001;
            d2 = (xord(k7)-xord(k3))^2+(yord(k7)-yord(k3))^2;
            if(d2>=d1)
                np(n2,1)=k1;
                np(n2,2)=k2;
                np(n2,3)=k3;
                np(n2,4)=k6;
                np(n2,5)=k9;
                np(n2,6)=k5;
                np(n1,1)=k1;
                np(n1,2)=k5;
                np(n1,3)=k9;
                np(n1,4)=k8;
                np(n1,5)=k7;
                np(n1,6)=k4;
            end
            if(d2<d1)
                np(n2,1)=k3;
                np(n2,2)=k5;
                np(n2,3)=k7;
                np(n2,4)=k4;
                np(n2,5)=k1;
                np(n2,6)=k2;
                np(n1,1)=k3;
                np(n1,2)=k6;
                np(n1,3)=k9;
                np(n1,4)=k8;
                np(n1,5)=k7;
                np(n1,6)=k5;
            end
        end

        if(meltyp==9)
            k1=2*(j-1)*i2+2*(k-1)+1;
            k2=k1+1;
            k3=k1+2;

            k4=k1+i2;
            k5=k4+1;
            k6=k4+2;

            k7=k1+2*i2;
            k8=k7+1;
            k9=k7+2;

            k1=npn(k1);
            k2=npn(k2);
            k3=npn(k3);
            k4=npn(k4);
            k5=npn(k5);
            k6=npn(k6);
            k7=npn(k7);
            k8=npn(k8);
            k9=npn(k9);

            np(n1,1) = k1;
            np(n1,2) = k2;
            np(n1,3) = k3;
            np(n1,4) = k6;
            np(n1,5) = k9;
            np(n1,6) = k8;
            np(n1,7) = k7;
            np(n1,8) = k4;
            np(n1,9) = k5;
        end

    end

end

