function taueff = CalcEffectiveStress(fighandle);
% SIGEFF = CalcEffectiveStress(FIGHANDLE)
% 
% This function accepts the handle FIGHANDLE to the main GUI and returns
% the vector SIGEFF (numels x 1) which contains the maximum octahedral
% shear stress in each element in the mesh. 
%
% The field sigeps must already exist in the main GUI data structure 
% (i.e. the function CalcStrainStress must already have been run) before 
% this function will work.

% get data structure
handles = guidata(fighandle);

% unpack necessary variables

% initialize output

% use maximum octahedral shear stress criterion
