function sigepsstruct=CalcStrainStress(fighandle)
% SIGEPSSTRUCT=CalcStrainStress(FIGHANDLE)
%
% This function accepts the handle FIGHANDLE to the main GUI and returns a structure
% SIGEPSSTRUCT with fields:
%         SIGEPSSTRUCT.eps      : strain (numels x 3)
%                                 = [x normal strain , y normal strain , shear strain]
%         SIGEPSSTRUCT.sig      : stress (numels x 3)
%                                 = [x normal stress , y normal stress , shear stress]
%         SIGEPSSTRUCT.rotation : rotation (numels x 3)
%                                 = [0 , 0 , rotation]
%         SIGEPSSTRUCT.rotrange   : maximum absolute value of rotation
%         SIGEPSSTRUCT.sigrange   : maximum absolute value of stress
%         SIGEPSSTRUCT.epsrange   : maximum absolute value of strain
%
% The field displ in the main GUI data structure must already exist (i.e. the solver
% must have successfully run) before this function will work.

% get the data structure
handles=guidata(fighandle);

% unpack necessary variables

% initialize necessary variables

% define material stiffness matrix using matlb function in redAnTS

% loop over the elements

    % get element's displacements

    % find shape fcn, s.f. derivative arrays using sf_arrs function
    % in redAnTS

    % form the strain, stress and rotation in each element

    % Update global matrices

% end loop

% save results to output structure
sigepsstruct = struct();
